import { ts } from '@midwayjs/mwcc';
declare const _default: {
    transform(): {
        /**
         * export default () => {}
         * =>
         * export default async function $default () {}
         */
        ExportAssignment(node: ts.ExportAssignment): ts.ExportAssignment | ts.FunctionDeclaration;
        /**
         * export default function () {}
         * =>
         * export default function $default () {}
         */
        FunctionDeclaration(node: ts.FunctionDeclaration): ts.FunctionDeclaration;
        /**
         * 将所有的 lambda & hook 的箭头函数转换为普通函数
         * export const useDemo = () => {}
         * =>
         * export const useDemo = function useDemo () {}
         */
        ArrowFunction(node: ts.ArrowFunction): ts.FunctionExpression | ts.ArrowFunction;
    };
};
export default _default;
