import type { FunctionStructure } from '@midwayjs/serverless-spec-builder';
import type { Dictionary } from 'lodash';
import type { LambdaParam } from '@midwayjs/hooks-shared';
import { FunctionRule } from '@midwayjs/hooks-shared';
declare type SourceFilePath = string;
export declare function addRoute(sourceFilePath: SourceFilePath, lambda: MidwayHooksFunctionStructure): void;
export declare function clearRoutes(): void;
export declare function getFunctionsMeta(): Dictionary<MidwayHooksFunctionStructure>;
export interface MidwayHooksFunctionStructure extends FunctionStructure {
    deployName: string;
    handler: string;
    sourceFilePath?: string;
    sourceFile?: string;
    exportFunction?: string;
    isFunctional?: boolean;
    argsPath?: string;
    gatewayConfig: Partial<LambdaParam>;
    event: FunctionRule['events'];
}
export declare function duplicateWarning(root: string, existPath: string, currentPath: string, api: string): void;
export {};
