import createDebug from 'debug';
import { ts } from '@midwayjs/mwcc';
export declare const debug: createDebug.Debugger;
export declare function getTopLevelNode(node: ts.Node): ts.Node;
export declare function isHookName(s: string): boolean;
export declare function isInsideLambdaOrHook(node: ts.Node): boolean;
export declare function isLambdaOrHook(node: ts.Node, container: ts.Node): boolean;
export declare function isHOC(node: ts.Node): boolean;
export declare function isLambda(node: ts.FunctionDeclaration | ts.FunctionExpression, container: ts.Node): boolean;
export declare function isExported(node: ts.FunctionDeclaration | ts.FunctionExpression, container: any): boolean;
export declare function hasModifier(node: any, modifier: ts.ModifierFlags): boolean;
export declare function getTopLevelNameNode(node: ts.Node): ts.Identifier;
export declare function isFunctionKind(kind: ts.SyntaxKind): boolean;
export declare type FunctionKind = ts.FunctionDeclaration | ts.ArrowFunction | ts.FunctionExpression;
export declare function closetAncestor<T extends ts.Node = ts.Node>(node: ts.Node, kind: ts.SyntaxKind): T;
export declare function closetAncestorWhileKind(node: ts.Node, condition: (ancestorKind: ts.SyntaxKind, currentNode?: ts.Node) => boolean): ts.Node;
/**
 * 处理循环递归情况，需要判断节点是不是在 ts.block 中
 */
export declare function isInBlock(node: ts.Node): boolean;
export declare function isLambdaOrHookVariableStatement(node: FunctionKind): boolean;
export declare function isHOCExportAssignment(node: FunctionKind): boolean;
export declare function getSourceFilePath(node: ts.Node): string;
export declare function removeExtension(file: string): string;
export declare function tryCatch<T extends (...args: unknown[]) => unknown>(fn: T, ...args: Parameters<T>): {
    value?: ReturnType<T>;
    error?: Error;
};
